$! 08-FEB-97  MGD  Modified for 0_8_1 and WASD HTTPd
$!
$! This procedure compiles the SSL sources into 2 libraries:
$!	[.CRYPTO]CRYPTO-xxx.OLB		! crypto-graphics subroutines
$!	[.SSL]SSL-xxx.OLB		! SSL protocol.
$!
$!  where 'xxx' specifies the machine achitecture: AXP or VAX
$!
$!  To perform 1 sub-option, specify P1 as one of:
$!	INCLUDE CRYPTO SSL APPS
$!
$!  Requirements:
$!	DECC 4.0   	(may work with other versions)
$!	OpenVMS 6.1	(may work with other versions)
$!
$! MGD
$ CC = "CC/NODEBUG/NOMEMBER_ALIGN/NOOPTIMIZE/NOWARN" +-
       "/DEFINE=(_VMS_V6_SOURCE,VMS)"
$ original_default = f$environment("DEFAULT")
$ proc = f$environment("PROCEDURE")
$ proc_dir = f$parse("1.1;1",proc) - "1.1;1"
$ set default 'proc_dir'
$!
$! MGD
$ IF P1 .EQS. "APPS" THEN GOTO APPS
$!
$! Copy all include files to [.include]
$!
$ set noon
$ if P1 .nes. "" then goto do_'p1'
$! MGD
$! do_include
$ do_include:
$ write sys$output "Rebuilding [.include] directory..."
$ delete [.include]*.h;*
$ backup [.*...]*.h; includes.bck/save
$ backup includes.bck/save [.include]
$ delete includes.bck;
$ if p1 .nes. "" then goto cleanup
$!
$! Build crypto lib.
$!
$ do_crypto:
$ write sys$Output "Making CRYPTO library"
$ set default [.crypto]
$ @libvms
$ set default [-]
$ if p1 .nes. "" then goto cleanup
$!
$! Build SSL lib.
$!
$ do_ssl:
$ write sys$output "Making SSL library"
$ set default [.ssl]
$ libname = "ssl-axp.olb"
$ if f$getsyi("CPU") .lt. 128 then libname = "ssl-vax.olb"
$ if f$search(libname) .eqs. "" then library/create/log 'libname'
$ cc ssl.c/include=[-.include]/prefix=all
$ library/replace 'libname' ssl.obj
$ set default [-]
$ if p1 .nes. "" then goto cleanup
$!
$! MGD
$ DELETE/NOLOG [...]*.SUBSET;*
$ DELETE/NOLOG [...]*.OBJ;*
$!! GOTO CLEANUP
$!
$! MGD
$ APPS:
$ write sys$output "Making applications"
$ LIBNAME = "[-.SSL]SSL-AXP.OLB"
$ IF F$GETSYI("CPU") .LT. 128 THEN LIBNAME = "[-.SSL]SSL-VAX.OLB"
$ CRYPTOLIB = "[-.CRYPTO]CRYPTO-" + F$ELEMENT(2,"-",LIBNAME)
$ SET DEFAULT [.APPS]
$ ARCH = "AXP"
$ IF F$GETSYI("CPU") .LT. 128 THEN ARCH = "VAX"
$ CC APPS.C/INCLUDE=[-...]/PREFIX=ALL
$ CC CA.C/INCLUDE=[-...]/PREFIX=ALL
$ LINK /EXEC=CA_'ARCH'.EXE CA,APPS,'LIBNAME'/LIBRARY,'CRYPTOLIB'/LIBRARY
$ CC CRL.C/INCLUDE=[-...]/PREFIX=ALL
$ LINK /EXEC=CRL_'ARCH'.EXE CRL,APPS,'LIBNAME'/LIBRARY,'CRYPTOLIB'/LIBRARY
$ CC CRL2P7.C/INCLUDE=[-...]/PREFIX=ALL
$ LINK /EXEC=CRL2P7_'ARCH'.EXE CRL2P7,APPS,'LIBNAME'/LIBRARY,'CRYPTOLIB'/LIBRARY
$ CC GENRSA.C/INCLUDE=[-...]/PREFIX=ALL
$ LINK /EXEC=GENRSA_'ARCH'.EXE GENRSA,APPS,'LIBNAME'/LIBRARY,'CRYPTOLIB'/LIBRARY
$ CC REQ.C/INCLUDE=[-...]/PREFIX=ALL
$ LINK /EXEC=REQ_'ARCH'.EXE REQ,APPS,'LIBNAME'/LIBRARY,'CRYPTOLIB'/LIBRARY
$ CC RSA.C/INCLUDE=[-...]/PREFIX=ALL
$ LINK /EXEC=RSA_'ARCH'.EXE RSA,APPS,'LIBNAME'/LIBRARY,'CRYPTOLIB'/LIBRARY
$ CC X509.C/INCLUDE=[-...]/PREFIX=ALL
$ LINK /EXEC=X509_'ARCH'.EXE X509,APPS,'LIBNAME'/LIBRARY,'CRYPTOLIB'/LIBRARY
$ CC VERIFY.C/INCLUDE=[-...]/PREFIX=ALL
$ LINK /EXEC=VERIFY_'ARCH'.EXE VERIFY,APPS,'LIBNAME'/LIBRARY,'CRYPTOLIB'/LIBRARY
$ SET PROT=W:RE *.EXE
$ DELETE/NOLOG []*.OBJ;*
$ GOTO CLEANUP
$!
$ cleanup:
$ set default 'original_default'
$ write sys$output "Done"
